% 8. tyden - SPEKTRALNI ODECITANI
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%

% Cisty signal
s=loadbin('../signaly/vm0.bin') ;
% Sum 10x zeslabime
n=0.1*loadbin('../signaly/nc3.bin') ;

% s Hammingovym vahovacim oknem
w=hamming(N);
% s obdelnikovym vahovacim oknem - problematicke odhady spektra
%w=ones(N,1);  

N=2000 ;
xframe = s(1:N) + n(1:N) ;
xframe=xframe(:).*w;

figure(1)
subplot(211)
plot(xframe)

X=fft(xframe);
Xabs=abs(X);
Xangle=angle(X);

subplot(212)
semilogy(Xabs)

% Odhad PSD Welchovou metodou - dvoustrany pro dalsi aplikaci ve SO
Npsd=pwelch(n,w,[],N,'twosided');
% Prepocet PSD na amplitudove spektrum
Nabs=sqrt(N*Npsd);


figure(1)
subplot(212)
hold on
semilogy(Nabs,'r')
hold off

% Spektralni odecitani s jednocestnym usmernenim 
% (tj. zaporne slozky jsou nulovany)
Yabs=(Xabs - Nabs).*(Xabs>Nabs) ;

y=real(ifft(Yabs.*exp(j*Xangle)));

figure(2)
subplot(211)
plot(y)
subplot(212)
semilogy(Yabs)


