%% priklad 7
clear;

%% parametry signalu
A = 1.0;
To = 5.0;
fo = 1/To;

%% volba fsa: fmax je 2*fo, proto fsa_min = 2*fmax+fo = 5*fo
% fsa musi byt cely nasobek fo
fsa = 5*fo; % MENIT nasobky fsa
%fsa = 10*fo; % 
%fsa = 50*fo; % 
Tsa = 1/fsa;

No = To/Tsa; %musi vyjit cele cislo (jinak jsem nedorzel podminku u fsa)

%% signal -- na intervalu jedne periody
cast = (0:No-1)*Tsa;
signal = 4*A*(cos(2*pi/To*cast)).^2;

figure(1);clf;
plot(cast, signal, 'b-x');
xlabel('t');
ylabel('s(t)');

%% vypocet spektra: 
%cn = Tsa/To*fft(signal); %stejne jako:
cn = 1/No*fft(signal);

%% zobrazeni spektra
figure(2);clf;
stem(0:No-1, abs(cn));
xlabel('n');
ylabel('|c_n|');

%% zobrazeni spektra -- fftshift()
figure(3);clf;
stem((0:No-1)-fix(No/2),fftshift(abs(cn)));
xlabel('n');
ylabel('|c_n|');
