% 8. tyden - PASMOVA FILTRACE V KMITOCTOVE OBLASTI

s=loadbin('../signaly/vm0.bin') ;

N=2000 ;
xframe = s(1:N) ;
xframe=xframe(:) ;

X=fft(xframe) ;
Xabs=abs(X);

figure(1)
subplot(211)
plot(xframe);
subplot(212)
% plot(Xabs);
semilogy(Xabs);

% Mezni frekvence pro pasmovou propust
fs=16000;
fc1=300;
fc2=3400;

% Mezni frekvence pro diksretni frekvenci na bazi DFT
k1=floor(fc1/fs*N);
k2=floor(fc2/fs*N);

% symetricka maska pro pasmovou propust
H=[zeros(k1,1); ones(k2-k1,1);  zeros(N-2*k2+1,1);  ones(k2-k1,1); zeros(k1-1,1)] ; 

figure(2)
plot(H)
title('Maska pasmoveho filtru')

% Fitlrce ve frekvencni oblasti
y=ifft(X.*H) ;

figure(3)
subplot(211)
% plot(abs(X.*H))
semilogy(abs(X.*H))
title('Spektrum pasmove omezeneho signalu')
subplot(212)
plot(y)
title('Pasmove omezeny signal v casove oblasti');