function y=quantize(x,bits);

q=2^(-(bits-1)) ;     %  quantization step

% Limitation of variable range

xleq = find(x <= -1) ;
x(xleq) = -1*ones(1,length(xleq)) ;

xg = find ( x > 1-q) ;
x(xg) = (1-q)*ones(1, length(xg) ) ;

if ( ( length(xleq) > 0 ) || ( length(xg) > 0 ) ) 
    disp(['Warning QUANTIZE: Appeared value outside of the range <-1, ' num2str(1-q) '> was limited.']);
end

% Quantization

y=q*floor(x/q) ;
% y=q*round(x/q) ;

